SystemOrganization addCategory: #SimpleApplescript!
SystemOrganization addCategory: #'SimpleApplescript-Specifications'!

TestCase subclass: #ApplescriptSpecification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleApplescript-Specifications'!

!ApplescriptSpecification methodsFor: 'tests' stamp: 'SeanDeNigris 12/6/2011 09:36'!
testDoIt

	| result |
	result := Applescript doIt: 'get item 1 of {"one", "two", "three"}'.
	self assert: (result = '"one"').! !

!ApplescriptSpecification methodsFor: 'tests' stamp: 'SeanDeNigris 12/6/2011 09:48'!
testDoItError

	self should: [ Applescript doIt: 'get item 1 of {"one"'] raise: Error whoseDescriptionIncludes: 'syntax error:' description: ''.
! !

Object subclass: #Applescript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleApplescript'!

!Applescript commentStamp: 'SeanDeNigris 12/6/2011 09:55' prior: 0!
I execute Applescript scripts via my class side #doIt:.

I am a bare-bones replacement for the class of the same name in the Applescript project (on Squeaksource) because the required plugin does not work on the new Cocoa Cog VMs.!

!Applescript class methodsFor: 'scripting' stamp: 'SeanDeNigris 1/6/2012 14:49'!
doIt: aString 

	| process escapedString output |
	escapedString := self escapeDoubleQuotesIn: aString.
	process := PipeableOSProcess waitForCommand: '/usr/bin/osascript -ss -e "', escapedString, '"'.
	process succeeded ifFalse: [ self error: process errorUpToEndOfFile ].
	output := process output withoutTrailingBlanks.
	process closePipes. "Per http://forum.world.st/Proper-way-to-use-many-PipeableOSProcesses-td69586.html"
	^ output.
! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 1/6/2012 11:38'!
escapeDoubleQuotesIn: aString
	"Should be in String, but this is all very experimental, so I'm keeping it contained"

	^ aString copyReplaceAll: '"' with: '\"' asTokens: false.! !
